import GLOOP.*;
public class Kugel{
    private GLKugel kugel;
    private Box dieBox;
    private Spielfeld feld;
    
    private double radius;
    private boolean istAktiv;
    private double vX, vZ;

    public Kugel(double pX, double pZ, Box pBox, Spielfeld pSpielfeld){
        radius = 15;  
        kugel = new GLKugel(pX, radius, pZ, radius, "Marmor.jpg");
        kugel.setzeFarbe(Math.random(),Math.random(),Math.random());
        istAktiv = true;
        vX = Math.random()*2 -1;
        vZ = Math.random()*2 -1;
        dieBox = pBox;
        feld = pSpielfeld;        
    }

    public void bewege(){
        //Nur aktive Kugel bewegen sich.
        if (istAktiv) {
            //Spielfeldrnder abtesten und ggf. die Bewegungsrichtung ndern.
            if (kugel.gibX()-15<-feld.gibBreite()/2 || kugel.gibX()+15>feld.gibBreite()/2){
                vX = -vX;
            }
            if (kugel.gibZ()-15<-feld.gibTiefe()/2 || kugel.gibZ()+15>feld.gibTiefe()/2){
                vZ = -vZ;
            }
            
            // Bewegen der Kugel
            kugel.verschiebe(vX,0,vZ);

            //Kollision mit der Box abtesten.
            if (kugel.gibX()-radius < dieBox.gibX()+dieBox.gibBreite()/2  &&
            kugel.gibX()+radius > dieBox.gibX()-dieBox.gibBreite()/2  &&
            kugel.gibZ()-radius < dieBox.gibZ()+dieBox.gibTiefe()/2  &&
            kugel.gibZ()+radius > dieBox.gibZ()-dieBox.gibTiefe()/2){
                istAktiv = false;
                kugel.setzeSichtbarkeit(false);
            }
        }
    }
        
    public boolean istAktiv(){
        return istAktiv;
    }
}
